// BaseView.cpp 
// Copyright ЃACrX http://www.ibis.ne.jp/
//          _Jh kamiya@ibis.ne.jp
// ŁF2002/4/19

#include "stdafx.h"
#include <math.h>
#include "Vector2d.h"
#include "Base.h"

#include "BaseDoc.h"
#include "BaseView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const double PI = 3.141592;
inline double DEG2RAD(double dDegree) {
	return 2.0 * PI * dDegree / 360.0;
}

/////////////////////////////////////////////////////////////////////////////
// CBaseView

IMPLEMENT_DYNCREATE(CBaseView, CView)

BEGIN_MESSAGE_MAP(CBaseView, CView)
	//{{AFX_MSG_MAP(CBaseView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBaseView NX̍\z/

CBaseView::CBaseView()
{
}

CBaseView::~CBaseView()
{
}

BOOL CBaseView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBaseView NX̕`

void CBaseView::OnDraw(CDC* pDC)
{
	//ԊǗ
	static DWORD dwPrev = GetTickCount();
	double dTick = ( GetTickCount() - dwPrev )/1000.0;
	dwPrev = GetTickCount();
	//ׂ
	static int nPrevScene = -1;
	bool bInit = false;
	if ( nPrevScene != m_nScene ) {//V[ςĂ
		bInit = true;
	}
	nPrevScene = m_nScene;
	//V[ɂ镪
	switch(m_nScene) {
	case 0:
		Draw00(pDC, dTick, bInit ); break;
	case 1:
		Draw01(pDC, dTick, bInit ); break;
	case 2:
		Draw02(pDC, dTick, bInit ); break;
	case 3:
		Draw03(pDC, dTick, bInit ); break;
	case 4:
		Draw04(pDC, dTick, bInit ); break;
	case 5:
		Draw05(pDC, dTick, bInit ); break;
	case 6:
		Draw06(pDC, dTick, bInit ); break;
	default:
		m_nScene = 0;
	}
	//V[\
	pDC->SetBkMode(TRANSPARENT);//͓̌
	pDC->TextOut(0,0,m_szSceneName);
	pDC->TextOut(0,20,"Press SPACE to Next Scene");
}

//V[0
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw00( CDC* pDC, double dTick, bool bInit )
{
	static double dCenterX, dCenterY, dRadius;
	if ( bInit ) {//
		dCenterX = 320.0;
		dCenterY = 240.0;
		dRadius = 220.0;
		strcpy(m_szSceneName,"Move Circle");
	}
	//~`
	bool bFirst = true;
	double x0,y0;
	for( double t = 0.0 ; t < 360.0 ; t+=1.0) {
		double x = dCenterX + dRadius * cos( DEG2RAD(t) );
		double y = dCenterY + dRadius * sin( DEG2RAD(t) );
		if ( bFirst ) {
			MoveTo(pDC, x, y );
			bFirst = false;
			x0 = x; y0 = y;
		} else {
			LineTo(pDC, x, y );
		}
	}
	LineTo(pDC, x0, y0);
	//ړ
	dCenterX += 100.0 * dTick; //1bԂ100hbgi
	if ( dCenterX-dRadius > 640 ) {
		dCenterX = -dRadius;
	}
}

//V[1
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw01( CDC* pDC, double dTick, bool bInit )
{
	static double dCenterX, dCenterY, dRadius, dRot;
	if ( bInit ) {//
		dCenterX = 320.0;
		dCenterY = 240.0;
		dRadius = 220.0;
		dRot = 0.0;//]px
		strcpy(m_szSceneName,"Naruto");
	}
	//Q`
	bool bFirst = true;
	double r = dRadius;
	for( double t = 0.0 ; r > 1.0 ; t+=1.0) {
		double x = dCenterX + r * cos( DEG2RAD(t+dRot) );
		double y = dCenterY + r * sin( DEG2RAD(t+dRot) );
		if ( bFirst ) {
			MoveTo(pDC, x, y );
			bFirst = false;
		} else {
			LineTo(pDC, x, y );
		}
		r -= 0.1;
	}
	//]
	dRot += 180.0 * dTick; //1bԂ180x]
}

//V[2
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw02( CDC* pDC, double dTick, bool bInit )
{
	static double dCenterX, dCenterY, dRadius, dRadius2, dR2Velo, dRot;
	if ( bInit ) {//
		dCenterX = 320.0;
		dCenterY = 240.0;
		dRadius = 220.0;//O~̔a
		dRadius2 = 0.0;//U
		dR2Velo = 1.0;//U̕ωx
		dRot = 0.0;//]px
		strcpy(m_szSceneName,"Flower");
	}
	//Ԃ`
	bool bFirst = true;
	double x0,y0;
	double r;
	for( double t = 0.0 ; t < 360.0 ; t+=1.0) {
		r = dRadius + dRadius2 * sin( DEG2RAD(t * 20.0) ) - dRadius2;
		double x = dCenterX + r * cos( DEG2RAD(t+dRot) );
		double y = dCenterY + r * sin( DEG2RAD(t+dRot) );
		if ( bFirst ) {
			MoveTo(pDC, x, y );
			bFirst = false;
			x0 = x; y0 = y;
		} else {
			LineTo(pDC, x, y );
		}
	}
	LineTo(pDC, x0, y0 );
	//]
	dRot += 10.0 * dTick; //1bԂ180x]
	//U̕ω
	dRadius2 += dR2Velo;
	if ( dRadius2 > 200.0 ) {
		dR2Velo = -1;
	} else if ( dRadius2 < 2.0 ) {
		dR2Velo = 1;
	}
}

//V[3
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw03( CDC* pDC, double dTick, bool bInit )
{
	static double dCenterX, dCenterY, dRadius, dRadius2, dR2Velo, dRot;
	if ( bInit ) {//
		dCenterX = 320.0;
		dCenterY = 240.0;
		dRadius = 120.0;//O~̔a
		dRadius2 = 10.0;//U
		dR2Velo = 1.0;//U̕ωx
		dRot = 0.0;//]px
		strcpy(m_szSceneName,"Circle Spring");
	}
	//~XvO`
	bool bFirst = true;
	double x0,y0;
	for( double t = 0.0 ; t < 360.0 ; t+=1.0) {
		double x = dCenterX + dRadius * cos( DEG2RAD(t+dRot) );
		double y = dCenterY + dRadius * sin( DEG2RAD(t+dRot) );
		x += dRadius2 * sin( DEG2RAD( t + t*24.0 ) );
		y += dRadius2 * cos( DEG2RAD( t + t*24.0 ) );
		if ( bFirst ) {
			MoveTo(pDC, x, y );
			bFirst = false;
			x0 = x; y0 = y;
		} else {
			LineTo(pDC, x, y );
		}
	}
	LineTo(pDC, x0, y0);
	//]
	dRot += 10.0 * dTick; //1bԂ180x]
	//U̕ω
	dRadius2 += dR2Velo;
	if ( dRadius2 > 100.0 ) {
		dR2Velo = -1;
	} else if ( dRadius2 < 2.0 ) {
		dR2Velo = 1;
	}
}

//V[4
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw04( CDC* pDC, double dTick, bool bInit )
{
	static double dTime,dCenterX,dCenterY,dRadius,dRVelo,dRot;
	static int nSide;
	if ( bInit ) {//
		dTime = 0.0;
		nSide = 3;
		dCenterX = 320.0;
		dCenterY = 240.0;
		dRadius = 220.0;//O~̔a
		dRVelo = 1.0;//a̕ωx
		dRot = 0.0;//]px
		strcpy(m_szSceneName,"Polygon");
	}
	//p``
	bool bFirst = true;
	double x0,y0;
	for( double t = 0.0 ; t < 360.0 ; t+= 360.0 / (double)nSide) {
		double x = dCenterX + dRadius * cos( DEG2RAD(t+dRot) );
		double y = dCenterY + dRadius * sin( DEG2RAD(t+dRot) );
		if ( bFirst ) {
			MoveTo(pDC, x, y );
			bFirst = false;
			x0 = x;
			y0 = y;
		} else {
			LineTo(pDC, x, y );
		}
	}
	LineTo(pDC, x0, y0 );
	//]
	dRot += 10.0 * dTick; //1bԂ180x]
	//a̕ω
	dRadius += dRVelo;
	if ( dRadius > 200.0 ) {
		dRVelo = -1;
	} else if ( dRadius < 2.0 ) {
		dRVelo = 1;
	}
	//p̕ω
	nSide = 3 + (int)(dTime/1.0);
	if ( nSide > 12 ) {
		dTime = 0.0;
	}
	dTime += dTick;
}

//V[5
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw05( CDC* pDC, double dTick, bool bInit )
{
	static double dCenterX, dCenterY, dRadius, dRadius2, dRot, dTime;
	if ( bInit ) {//
		dCenterX = 320.0;
		dCenterY = 240.0;
		dRadius = 50.0;
		dRadius2 = 20.0;//a
		dRot = 0.0;//]px
		dTime = 0.0; //
		strcpy(m_szSceneName,"Straight Spring");
	}
	//XvO`
	bool bFirst = true;
	for( double t = 0.0 ; t < 3600.0 ; t+=10.0) {
		double x = dCenterX + (t/3600.0) * dRadius * cos( DEG2RAD(dRot) );
		double y = dCenterY + (t/3600.0) * dRadius * sin( DEG2RAD(dRot) );
		x += dRadius2 * cos( DEG2RAD( dRot + t ) );
		y += dRadius2 * sin( DEG2RAD( dRot + t ) );
		if ( bFirst ) {
			MoveTo(pDC, x, y );
			bFirst = false;
		} else {
			LineTo(pDC, x, y );
		}
	}
	//]
	dRot += 30.0 * dTick;
	//Lяk
	dRadius += 400.0 * sin( dTime * 4.0 ) * dTick;
	//Ԃ߂
	dTime += dTick;
}

//V[6
//dTick : oߎԁiPʁFbj
//bInit : ׂ
void CBaseView::Draw06( CDC* pDC, double dTick, bool bInit )
{
	static CVector2d vPos,vVelocity;
	if ( bInit ) {//
		vPos.Set(320.0,240.0);
		vVelocity.Set(3.0,0);
		strcpy(m_szSceneName,"2D Vector");
	}
	//`
	CVector2d vHead = vPos+(vVelocity * 3.0);
	MoveTo(pDC,vPos); LineTo(pDC,vHead);//S
	CVector2d vArrow = ( vPos - vHead ) / 3.0;
	MoveTo(pDC,vHead); LineTo(pDC,vHead+ vArrow.GetRotate(DEG2RAD( 20.0)));
	MoveTo(pDC,vHead); LineTo(pDC,vHead+ vArrow.GetRotate(DEG2RAD(-20.0)));

	//̈ړ
	vPos += vVelocity;

	//L[ŉ]
	if ( GetAsyncKeyState( VK_LEFT ) < 0 ) {//J[\L[
		vVelocity.Rotate( DEG2RAD( 10.0) );//10x
	}
	if ( GetAsyncKeyState( VK_RIGHT ) < 0 ) {//EJ[\L[
		vVelocity.Rotate( DEG2RAD(-10.0) );//10xE
	}
	if ( GetAsyncKeyState( VK_UP ) < 0 ) {//J[\L[
		vVelocity += vVelocity.GetNormal() * 2.0;//
	}
	if ( GetAsyncKeyState( VK_DOWN ) < 0 ) {//J[\L[
		vVelocity -= vVelocity.GetNormal() * 2.0;//
	}
	//[v
	if ( vPos.GetX() > 640.0 ) vPos -= CVector2d( 640.0, 0.0 );
	if ( vPos.GetX() <   0.0 ) vPos += CVector2d( 640.0, 0.0 );
	if ( vPos.GetY() > 480.0 ) vPos -= CVector2d( 0.0, 480.0 );
	if ( vPos.GetY() <   0.0 ) vPos += CVector2d( 0.0, 480.0 );
}

void CBaseView::MoveTo(CDC* pDC, CVector2d v ){
	MoveTo(pDC,v.GetX(),v.GetY());
}
void CBaseView::LineTo(CDC* pDC, CVector2d v ){
	LineTo(pDC,v.GetX(),v.GetY());
}

void CBaseView::MoveTo(CDC* pDC, double x, double y ) 
{
	CPoint p = ConvertCoord( x, y );
	pDC->MoveTo( p );
}

void CBaseView::LineTo(CDC* pDC, double x, double y ) 
{
	CPoint p = ConvertCoord( x, y );
	pDC->LineTo( p );
}

CPoint CBaseView::ConvertCoord( double x, double y ) 
{
	CPoint p;
	CRect cr;
	GetClientRect( &cr );
	if ( cr.right > cr.bottom ) {
		double w =(double)cr.bottom * 640.0/480.0;
		p.x = (int)((double)cr.bottom * x / 480.0 + ((double)cr.right-w)/2);
		p.y = (int)((double)cr.bottom * y / 480.0);
	} else {
		double h =(double)cr.right * 480.0 / 640.0;
		p.x = (int)((double)cr.right * x / 640.0);
		p.y = (int)((double)cr.right * y / 640.0 + ((double)cr.bottom-h)/2);
	}
	return p;
}
/////////////////////////////////////////////////////////////////////////////
// CBaseView NẌ

BOOL CBaseView::OnPreparePrinting(CPrintInfo* pInfo)
{
	return DoPreparePrinting(pInfo);
}

void CBaseView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CBaseView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CBaseView NX̐ff

#ifdef _DEBUG
void CBaseView::AssertValid() const
{
	CView::AssertValid();
}

void CBaseView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBaseDoc* CBaseView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBaseDoc)));
	return (CBaseDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBaseView NX̃bZ[W nh

int CBaseView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	//^C}[Zbg
	SetTimer(1,50,NULL);
	//V[
	m_nScene = 0;
	return 0;
}

void CBaseView::OnDestroy() 
{
	CView::OnDestroy();
	//^C}[폜
	KillTimer(1);	
}

void CBaseView::OnTimer(UINT nIDEvent) 
{
	Invalidate(TRUE);	
	CView::OnTimer(nIDEvent);
}


void CBaseView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if ( nChar == VK_SPACE ) {//Xy[XL[
		m_nScene ++;//̃V[
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
